(function($) {


  $.fn.iDraggable = function(options) {
    
    var options = $.extend({
      droppedClass: 'iD-dropped',
      revert: true,
	  magnetX: 0,
	  minX: 0,
	  maxX: 320,
	  distance: 0
    }, options);
	
	var newOffset;
	var startFingerOffset;
	var alreadyScrolling;
	var distanceCovered;
	
	var momentum = null;
	var recPos = null;
	var recPosDelta = null;
	
  	return this.each(function() {
      $(this).addClass('iDraggable');
      var offset = null;
      var origOffset = $(this).offset();
      var matrix = new WebKitCSSMatrix($(this).css('transform'));
      var transform = {				// transform incase drags are initialized while dropped
      	left: matrix.m41,
      	top: matrix.m42
      };
      var origPos = {
      	left: origOffset.left - transform.left,
      	top: origOffset.top - transform.top
      };							// this is the offset used to position drags
      var start = function(e) {
        //e.preventDefault();
      	e.stopPropagation();
		alreadyScrolling = false;
		distanceCovered = 0;
      	var orig = (e.type === "mousedown") ? e.originalEvent : e.originalEvent.changedTouches[0];
     		startOffset = $(this).offset();
		startFingerOffset = {
			x: orig.pageX,
			y: orig.pageY,
		}
        offset = {
          x: orig.pageX - startOffset.left,
          y: orig.pageY - startOffset.top
        };
		
		momentum = 0;
		recPos = 0;
		recPosDelta = 0;
		
		
        $(this).bind("touchmove mousemove", moveMe);
        $(this).bind("touchend mouseup", dropMe);
      };
      var moveMe = function(e) {  
		$(this).css('-webkit-transition','all 0');
      	
      	e.stopPropagation();
        var orig = (e.type === "mousemove") ? e.originalEvent : e.originalEvent.changedTouches[0];
		
		//console.log(startFingerOffset.x);

			if((Math.abs(orig.pageY-startFingerOffset.y) > Math.abs(orig.pageX - startFingerOffset.x)) && alreadyScrolling == false) {
				//We gaan horizontaal ipv verticaal.
				//e.originalEvent;
				//console.log('Geen X movement');
				
				//Wel de newoffset plaatsen:
				newOffset = {
				  x: orig.pageX - offset.x - origPos.left,
				  y: orig.pageY - offset.y - origPos.top
				};
				
				$(this).unbind('touchmove mousemove');
			} else {
				if((Math.abs(orig.pageX - startFingerOffset.x) > options.distance) || alreadyScrolling == true) {
					
					alreadyScrolling = true;
					e.preventDefault();
					//console.log('X movement');
					newOffset = {
					  x: orig.pageX - offset.x - origPos.left,
					  y: orig.pageY - offset.y - origPos.top
					};
					if(newOffset.x < options.minX) {
						newOffset.x = options.minX;
					}
					if(newOffset.x > options.maxX) {
						newOffset.x = options.maxX;
					}
					
					//HUIDIG is orig.pageX, vorige is recpos
					recPosDelta = orig.pageX - recPos;
					recPos = orig.pageX;
					
					$(this).css({ 
						'transform': 'translate(' + newOffset.x + 'px, 0px) translatez(1px)'
					});
				}
			}
		
      };
      var dropMe = function(e) {
		   $(this).css('-webkit-transition','all 0.3s');
        var orig = (e.type === "mouseup") ? e.originalEvent : e.originalEvent.changedTouches[0];
        var finger = {
          x: orig.pageX,
          y: orig.pageY
        };
      	var $drag = $(this);
      	var offset = $drag.offset();
      	var droppedInto = null;
    		/*$('.iDroppable').each(function() {
    			var box = $(this).data().box;
    			var dropActive = !$(this).hasClass(options.droppedClass);
    			if (dropActive && (box.left <= finger.x) && (finger.x <= box.right) && (box.top <= finger.y) && (finger.y <= box.bottom)) {
            droppedInto = this;
    				var offset = {
    					x: box.left - origPos.left,
    					y: box.top - origPos.top
    				};
            $(droppedInto).addClass(options.droppedClass);
    				$drag.css({ 
    					'transform': 'translate(' + offset.x + 'px, ' + offset.y + 'px) translatez(0)' 
    				})
            .addClass(options.droppedClass)
            .one("touchstart mousedown", function(e) {
              $(droppedInto).removeClass(options.droppedClass);
            });
    			}
    		});*/
			
    		if (!droppedInto && options.revert) {
				
				addToGoal = recPosDelta*8;
				if(addToGoal > 150) {
					addToGoal = 150;
				}
				if(addToGoal < -150) {
					addToGoal = -150;
				}
				
				goal = newOffset.x + (addToGoal);
				translatedTo = 0;
				if(goal > options.magnetX) {
					$(this).css({ 
						'transform': 'translate('+options.maxX+'px, 0px) translatez(0)'
					}).removeClass(options.droppedClass);
					translatedTo = options.maxX;
				} else {
					$(this).css({ 
						'transform': 'translate('+options.minX+'px, 0px) translatez(0)'
					}).removeClass(options.droppedClass);
					translatedTo = options.minX;
				}
    		} else if (!droppedInto) {
          var matrix = new WebKitCSSMatrix($(this).css('transform'));
          var transform = {       // transform incase drags are initialized while dropped
            left: matrix.m41,
            top: matrix.m42
          };
          $(this).css({
            'transform': 'translate(' + transform.left + 'px, ' + transform.top + 'px) translatez(0)'
          }).removeClass(options.droppedClass);
        }
        if (options.drop) {
          options.drop({ draggable: this, droppable: droppedInto, translatedTo: translatedTo });
        }
        $(this).unbind("touchmove mousemove", moveMe);
        $(this).unbind("touchend mouseup", dropMe);
        var _this = this;
        $(window).bind("resize", function() { 
          resize(_this);
        });
      };
      var resize = function(drag) {
        if (dragInput[$(drag).attr('id').toString()]) {
          var box = $("#" + dragInput[$(drag).attr('id').toString()]).data();
          var offset = {
            x: box.left - origPos.left,
            y: box.top - origPos.top
          };
          $(drag).css({ 
            'transform': 'translate(' + offset.x + 'px, ' + offset.y + 'px) translatez(0)' 
          });
        }
      };
	  
	  
      $(this).bind("touchstart mousedown", start);
    });
  };

  $.fn.iDroppable = function() {
    return this.each(function() {
    	var offset = $(this).offset();
    	var box = {
    		left: offset.left,
    		top: offset.top,
    		right: offset.left + $(this).width(),
    		bottom: offset.top + $(this).height()
    	};
    	$(this).data('box', box).addClass('iDroppable');
      var _this = this;
      $(window).bind("resize", function() { $(_this).iDroppable(); });
  	});
  };
}(jQuery));