// JavaScript Document
function setActive(target) {
	$(target).siblings().removeClass('active');
	$(target).addClass('active');
}
function switchIcon(target, first, last) {
	if($(target).hasClass(first)) {
		$(target).removeClass(first);
		$(target).addClass(last);
	} else {
		$(target).removeClass(last);
		$(target).addClass(first);
	}
}
function showHideElement(target) {
	console.log('SH: '+$(target).attr('class'));
	if($(target).hasClass('show')) {
		$(target).removeClass('show');
		setTimeout(function() {
			$(target).css('display','none');
		},400);
	} else {
		$(target).css('display','inline-block');
		setTimeout(function() {
		$(target).addClass('show');
		},100);
	}
}
function showElement(classname) {
	$('.'+classname).addClass('show');
}
function hideElement(classname) {
	$('.'+classname).removeClass('show');
}
function setMapHeight(classname) {
	height = $(window).height();
	$('.page > *:not(.'+classname+')').each(function() {
		thisheight = $(this).outerHeight(true);
		height = height-thisheight;
	});
	height = height-$('.header').height();
	$('.page .'+classname).css('height', height+'px');
}
function showFirstSetDone() {
	if($('div.concept[done=done]').doesExist()) {
		$('div.concept[done=done]').next().find('.setdone').css('display','block');
	} else {
		$('div.concept[done=notdone]').first().find('.setdone').css('display','block');
	}
}
function setBackButton(href) {
	$('.header .action.back').remove();
	html = '<div class="action back" onclick="loadPage(\''+href+'\');"><div class="icon"></div></div>';
	$('.header').append(html);
}
function setBackButtonCode(code) {
	$('.header .action.back').attr('onclick',code);
}
function clearBackButton() {
	$('.header .action.back').remove();
}
function switchTrendtourList() {
	showHideElement('trendtourlist');
	switchIcon($('.trendtour_switch'),'map','list');
	switchBackButton();
}
function switchBackButton() {
	if($('.trendtour_switch').hasClass('map')) {
		cde = 'showHideElement(\'trendtourlist\'); switchIcon($(\'.trendtour_switch\'),\'map\',\'list\'); switchBackButton();';
		setBackButtonCode(cde);	
	} else {
		setBackButton('map.html');
	}
}

function switchListviewElement(classname, target) {
	if($(target).hasClass(classname)) {
		$(target).removeClass(classname);
		switchSort();
		//hideListView();
		//$('.leaflet-shadow-pane, .leaflet-overlay-pane, .leaflet-marker-pane, .leaflet-popup-pane').removeClass('hide');
	} else {
		$(target).addClass(classname);
		switchSort();
		//$('.leaflet-shadow-pane, .leaflet-overlay-pane, .leaflet-marker-pane, .leaflet-popup-pane').addClass('hide');
		//showListView();
	}
}
function listWipeRight() {
	$('.switch_title.head_switch').addClass('list');
	switchSort();
	//$('.leaflet-shadow-pane, .leaflet-overlay-pane, .leaflet-marker-pane, .leaflet-popup-pane').addClass('hide');
	//showListView();
}
function listWipeLeft() {
	$('.switch_title.head_switch').removeClass('list');
	switchSort();
	//hideListView();
	//$('.leaflet-shadow-pane, .leaflet-overlay-pane, .leaflet-marker-pane, .leaflet-popup-pane').removeClass('hide');
}

function nextSlide(target) {
	num = $(target).closest('.slide').next().attr('slidenum');
	num = parseFloat(num)-1;
	console.log(num);
	//x van daysslider
	x_events = num*window_width;
	
	back_x = (num*60)+30;
	$('.firstopen > div.slidesholder').css({ 
		'transform': 'translate(-' + x_events + 'px, 0px) translatez(1px)'
	});
	/*$('.firstopen > div.background').addClass('blur');
	$('.firstopen > div.background').css({
		'transform': 'translate(-' + back_x + 'px, 0px) translatez(1px)'
	});*/
}
function prevSlide(target) {
	num = $(target).closest('.slide').prev().attr('slidenum');
	num = parseFloat(num)-1;
	console.log(num);
	//x van daysslider
	x_events = num*window_width;
	back_x = (num*60)+30;
	$('.firstopen > div.slidesholder').css({ 
		'transform': 'translate(-' + x_events + 'px, 0px) translatez(1px)'
	});
	/*$('.firstopen > div.background').css({
		'transform': 'translate(-' + back_x + 'px, 0px) translatez(1px)'
	});*/
}
function showLoading(target) {
	html = '<div class="loading_holder"><i class="fa fa-spinner fa-pulse fa-3x fa-fw"></i></div>';
	$(target).prepend(html);
}
function hideLoading() {
	$('.loading_holder').remove();
}
function fadeMeIn(obj) {
	setTimeout(function() {
	    $(obj).fadeIn(1000);
	},200);
}
function scrollMaskToHere(target) {
	no = $(target).index();
	pos = (window_width/5)*no;
	$('.main_menu.over').css('-webkit-mask-position',pos + 'px 0px');
}